static char *vhBrowser=
/********************************************************************
 *                                                                  *
 *                        EDSS Software Bus                         *
 */ "EDSS_SB Browser.h 0.5.1/prt/ncsu.csc/balay/16-Aug-95";/*
 *                                                                  *
 *                     Copyright (c) 1994 by                        *
 *                                                                  *
 *                  North Carolina State University                 *
 *              Department of Computer Science, Box 8206            *
 *                      Raleigh, NC 27695-8206                      *
 *                               and                                *
 *           MCNC, North Carolina Supercomputing Center             *
 *              Environmental Programs, P.O. Box 12889              *
 *                 Research Triangle Park, 27709                    *
 *        Released under the terms of the GNU Public License        *
 *                                                                  *
 ********************************************************************/

/********************************************************************
                    About:  EDSS_SB - Browser.h

 Browser.h contains the definitions necessary for the motif-busclient,
 Browser.

 INPUT FILES:       stdin stream
 OUTPUT FILES:      stdout stream
 ERROR HANDLING:    output to stderr (screen)
 INPUT PARAMETERS:  client name (ascii string), optional
 INPUT OPTIONS:     if client name is not input, default is

 NETWORKING:        remote/network connectivity is via bus library (sockets)

 COMPILATION:       (see makefile)

 KNOWN BUGS:  :-(

 OTHER NOTES: :-)

 ********************************************************************/

/* @(#)Browser.h	1.8 /env/proj/archive/edss/src/clients/browser/SCCS/s.Browser.h 08/19/96 13:44:37 */

/********************************************************************
                 History: EDSS_SB - Browser.c

 Date: 11-Apr-95
 Version: 0.3
 Change Description: ORIGINAL CODE
 Change author: Rajini Balay, NCSU, CSC

 Date: 23-July-95
 Version: 0.5
 Change Description: Added include files for gethostbyaddr.
 Change author: Rajini Balay, NCSU, CSC

 Date: 16-Aug-95
 Version: 0.5
 Change Description: Added defn for FSB_FILTER 
 Change author: Rajini Balay, NCSU, CSC

 ********************************************************************/

#include <stdio.h>
#include <string.h>
#include <X11/Xos.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>		/* for AF_INET */
#include <stdlib.h>

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/List.h>
#include <Xm/FileSB.h> 
#include <Xm/Form.h> 
#include <Xm/SelectioB.h>
#include <Xm/MessageB.h>

#include "bus.h"
#include "busFtp.h"

/* DEFINES */
#define FSB_OK        1
#define FSB_CANCEL    2
#define FSB_HOST      3
#define FSB_FILTER    4

#define HST_OK        10
#define HST_CANCEL    11
#define HST_USER      12
#define HST_PATH      13

#define USER_OK       20
#define USER_CANCEL   21

#define PATH_OK       30
#define PATH_CANCEL   31

#define OK            100
#define CANCEL        101

#define MAX_FILES     512

struct host_item {
    char hname[80];
    char pathname[256];
};

/* Function Definitions */
void mmessage(char *message);
void mwessage(char *message);
void merror(char *message);
void unmapFileList();

/* int gethostname(char *name, int namelen); */
char *cuserid(char *s);
struct dirent *readdir(DIR *dirp);

void UpdateHostDialog();

/* Callback functions */
void ASCIIZ_callback( struct BusData *bd, struct BusMessage *bmsg );
void recv_dir_callback(struct BusData *bd, struct BusMessage *bmsg);
void Seize_callback(struct BusData *bd, struct BusMessage *bmsg);
void Release_callback(struct BusData *bd, struct BusMessage *bmsg);

void dir_search(Widget widget, XtPointer search_data);
void rem_dir_search(Widget widget, XtPointer search_data);
void file_search(Widget widget, XtPointer search_data);
void UpdateDirWidget (Widget widget, int nitems, char **fileList);
void UpdateFileWidget (Widget widget, int nitems, char **fileList);
