#ifndef SBUS_FTP_H_INCLUDED
#define SBUS_FTP_H_INCLUDED

#ifdef SBUS_INCLUDE_HDR_DEFN
static char *vhbusFtp=
/********************************************************************
 *                                                                  *
 *                        EDSS Software Bus                         *
 */ "EDSS_SB busFtp.h 0.3/prt/ncsu.csc/balay/17-Jan-95";/*
 *                                                                  *
 *                     Copyright (c) 1994 by                        *
 *                                                                  *
 *                  North Carolina State University                 *
 *              Department of Computer Science, Box 8206            *
 *                      Raleigh, NC 27695-8206                      *
 *                               and                                *
 *           MCNC, North Carolina Supercomputing Center             *
 *              Environmental Programs, P.O. Box 12889              *
 *                 Research Triangle Park, 27709                    *
 *     Made available under terms of the GNU Public License         *
 *                                                                  *
 ********************************************************************/
#endif

/********************************************************************
                    About:  EDSS_SB - busFtp.h

 busFtp.h is a header file for bus utility functions for transferring files
 between machines.

 INPUT FILES:       stdin stream
 OUTPUT FILES:      stdout stream
 ERROR HANDLING:    output to stderr (screen)
 INPUT PARAMETERS:  client name (ascii string), optional
 INPUT OPTIONS:     if client name is not input, default is

 NETWORKING:        remote/network connectivity is via bus library (sockets)

 COMPILATION:       (see makefile)

 KNOWN BUGS:  :-(

 OTHER NOTES: :-)

 ********************************************************************/

/* @(#)busFtp.h	1.5 /tmp_mnt/pub/storage/edss/framework/src/bus/bus_ftp/SCCS/s.busFtp.h 19 Aug 1995 17:53:56 */

/********************************************************************
                 History: EDSS_SB - busFtp.h

 Date: 1-Feb-95
 Version: 0.3
 Change Description: ORIGINAL CODE
 Change author: Rajini Balay, NCSU, CSC

 ********************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
/* #include <sys/dir.h> */
#include <dirent.h> 
#include <unistd.h>
#include <sys/file.h>
#include <netdb.h>
#include <netinet/in.h>

#include "bus.h"

#define MAXLINE		1024
#define MAXDATA 4000
#define MAXNUMFILES 512
#define FTP_ERR_FOPEN -1
#define FTP_ERR_NONE   1
#define FTP_ERR_HOST  -2
#define FTP_ERR_LOCALHOST -3
#define FTP_ERR_CONNECT -4

#define FTP_GET 1
#define FTP_PUT 2

#define DIR_OPEN_ERR  -1
#define DIR_HOST_UNKNOWN -2
#define DIR_REMOTE_FETCH -3

#define IS_DIR 0
#define IS_FILE 1


#define DEBUG_FTP 0


int FTP_xferBINARY(struct BusData *bd, int mode, char *hostName, 
		  char *localFile, char *remoteFile);

/* Functions for Directory search */
int FTP_getdir(struct BusData *bd, char *hname, char *directory, int code, 
		int returnType, char **fileList);
int FTP_dirRemote(struct BusData *bd, char *ipaddr, char *directory, 
		int code, int returnType);
int FTP_dirLocal(char *directory, int code, char **fList);

int is_localhost(char *hname, char *ipaddr);
int is_accessible(char *file);

#endif  /* SBUS_FTP_H_INCLUDED */
