/* so that this header isn't included twice... */ 
#ifndef SBUS_RESPONSE_REQUEST_H_INCLUDED 
#define SBUS_RESPONSE_REQUEST_H_INCLUDED
#ifdef SBUS_INCLUDE_HDR_DEFN
static char *vhbusRepReq=
/********************************************************************
 *                                                                  *
 *                        EDSS Software Bus                         */
   "EDSS_SB busRepReq.h 0.4/prt/ncsu.csc/morrison.vouk.balay/18-Mar-95";
/*                                                                  *
 *                     Copyright (c) 1994 by                        *
 *                                                                  *
 *                  North Carolina State University                 *
 *              Department of Computer Science, Box 8206            *
 *                      Raleigh, NC 27695-8206                      *
 *                               and                                *
 *           MCNC, North Carolina Supercomputing Center             *
 *              Environmental Programs, P.O. Box 12889              *
 *                 Research Triangle Park, 27709                    *
 *                                                                  *
 *      Made available under terms of the GNU Public License        *
 *                                                                  *
 ********************************************************************/
#endif

/* @(#)busRepReq.h	1.3 /tmp_mnt/pub/storage/edss/framework/src/bus/bus_src/SCCS/s.busRepReq.h 08 Sep 1995 10:58:15" */


/********************************************************************
                    About:  EDSS_SB - busRepReq.h

  Bus message request/reply code definitions.

 ********************************************************************/

/********************************************************************
                 History: EDSS_SB - busRepReq.h

 Date: 14-Dec-94
 Version: 0.1
 Change Description: ORIGINAL VERSION 
 Change author: Leland Morrison, NCSU, CSC 

 Date: 15-Dec-94
 Version: 0.2
 Change Description: Added some comments and main headers
 Change author: Vouk

 Date: 7-Jan-95 
 Version: 0.2.1
 Change Description: Added definitions of FIND_NAME_ERR and FIND_ID_ERR 
 Change author: Rajini Balay, NCSU, CSC 

 Date: 18-March-95
 Version: 0.4
 Change Description: Definitions for BUSBYTE_FIND_MODULE_BY_NAME and
                     BUSBYTE_FIND_MODULE_BY_ID 
 Change author: Balay, R.

 Date: 12-Apr-95
 Version: 0.5a
 Change Description: Added definitions for BUSBYTE_KILL_CLIENT
 Change author: Balay, R.

 ********************************************************************/

#define BUSBYTE_RESET_CONNECTION     0x00
#define BUSBYTE_MODULE_LEAVING       0x05
#define BUSBYTE_SHUTDOWN             0x0a

/* #define BUSBYTE_MESSAGE_WAITING      0x11 */
#define BUSBYTE_MESSAGE_HERE 	     0x11 
#define BUSBYTE_PLEASE_ACKNOWLEDGE   0x22

#define BUSBYTE_ACKNOWLEDGEMENT      0x24
#define BUSBYTE_GET_FIRST_MESSAGE    0x14
#define BUSBYTE_DEQUE_MESSAGE  	     0x18

#define BUSBYTE_REGISTER_TYPE        0x33

#define BUSBYTE_FIND_MODULE_BY_NAME  0x41
#define BUSBYTE_FIND_MODULE_BY_ID    0x42
#define BUSBYTE_FIND_TYPE_BY_NAME    0x44
#define BUSBYTE_FIND_TYPE_BY_ID      0x48

#define BUSBYTE_WHOS_CONNECTED       0x4a
#define BUSBYTE_MODULE_INFO_BY_NAME  0x4b
#define BUSBYTE_MODULE_INFO_BY_ID    0x4c

#define BUSBYTE_REQ_DIRECT_CONNECT   0x50
#define BUSBYTE_DIRECT_CONNECT_OK    0x51
#define BUSBYTE_DIRECT_CONNECT_FAIL  0x52
#define BUSBYTE_DIRECT_CONNECT_DELAY 0x53
#define BUSBYTE_REPLY_DIRECT_CONNECT 0x54

#define BUSBYTE_KILL_CLIENT          0x55

#define BUSBYTE_I_DONT_UNDERSTAND    0xff

#endif
