/* so that this header isn't included twice... */
#ifndef BUS_SOCKET_INCLUDED
#define BUS_SOCKET_INCLUDED

#ifdef SBUS_INCLUDE_HDR_DEFN
static char *vhbusSocket=
/********************************************************************
 *                                                                  *
 *                        EDSS Software Bus                         */
    "EDSS_SB busSocket.h 0.2/prt/ncsu.csc/morrison.vouk/14-Dec-94";
/*                                                                  *
 *                     Copyright (c) 1994 by                        *
 *                                                                  *
 *                  North Carolina State University                 *
 *              Department of Computer Science, Box 8206            *
 *                      Raleigh, NC 27695-8206                      *
 *                               and                                *
 *           MCNC, North Carolina Supercomputing Center             *
 *              Environmental Programs, P.O. Box 12889              *
 *                 Research Triangle Park, 27709                    *
 *                                                                  *
 *      Made available under terms of the GNU Public License        *
 *                                                                  *
 ********************************************************************/
#endif

/* @(#)busSocket.h	1.2 /tmp_mnt/pub/storage/edss/framework/src/bus/bus_src/SCCS/s.busSocket.h 13 Jul 1995 16:23:43 */


/********************************************************************
                    About:  EDSS_SB - busSocket.h

  Definitions, structures and prototypes for the bus socket manipulation
  routines.

 ********************************************************************/

/********************************************************************
                 History: EDSS_SB - busSocket.h

 Date: 14-Dec-94
 Version: 0.1
 Change Description: ORIGINAL VERSION 
 Change author: Leland Morrison, NCSU, CSC 

 Date: 15-Dec-94
 Version: 0.2
 Change Description: Added some comments and main headers
 Change author: Vouk

 ********************************************************************/

/* First, prototypes for socket related function for systems
   lacking them */
/* sys/types.h, sys/socket.h, sys/time.h
   should be included by this file */

/* Include files added by Rajini */
#include <sys/types.h>
#include <sys/time.h>

#ifndef NOFDSETPTR
#define SELECTFDSETPTR fd_set *
#else
#define SELECTFDSETPTR int *
#endif /* NOFDSETPTR */

#ifndef INADDR_LOOPBACK
#define INADDR_LOOPBACK (0x7f000001)
#endif

#ifdef INCLUDE_SOCKET_PROTOTYPES

/* Standard TCP/IP socket connection routines */
int accept(int s, struct sockaddr *addr, int *addrlen);
int bind(int s, const struct sockaddr *name, int namelen);
int close(int);
int connect(int s, struct sockaddr *name, int namelen);
struct hostent *gethostbyname( char *host_name );
char *gethostname( char *name, int namelen ); /* namelen should be 32 */
int getsockname(int s, struct sockaddr *name, int *namelen);
int listen(int s, int backlog);
int shutdown(int s, int how);
int socket(int domain, int type, int protocol);

#ifndef FD_SETSIZE
int getdtablesize( void );
#define FD_SETSIZE (getdtablesize())
#endif

#ifndef NOFDSETPTR
int select(int nfds, fd_set *readfds, fd_set *writefds,
	   fd_set *exceptfds, struct timeval *timeout);
#else
int select(int nfds, int *readfds, int *writefds,
	   int *exceptfds, struct timeval *timeout);
#endif /* NOFDSETPTR */

int sendto(int s, const char *msg, int len, int flags,
	   const struct sockaddr *to, int tolen);

int recvfrom(int s, char *buf, int len, int flags,
	     struct sockaddr *from, int *fromlen);

#else  /* INCLUDE_SOCKET_PROTOTYPES */
#endif /* INCLUDE_SOCKET_PROTOTYPES */

/* Now for the functions defined in busSocket.c */

int busSocket_createAcceptorSocket(int *portNumber);
int busSocket_makeBoundConnectionless( int *portNumber );
int busSocket_acceptConnection(int portSocket,
			       struct sockaddr_in *sad );
int busSocket_acceptFromConnectionless(int portSocket,
				       struct sockaddr_in *sin);
int busSocket_makeConnection(char *host_addr, int port);

#endif
