char *vcbusXt=
/******************************************************************** 
 *                                                                  * 
 *                        EDSS Software Bus                         *
 */"EDSS_SB busXt.c 0.6a/prt/ncsu.csc/morrison.vouk.balay/24-July-95";/* 
 *                                                                  * 
 *                     Copyright (c) 1994 by                        *
 *                                                                  * 
 *                  North Carolina State University                 * 
 *              Department of Computer Science, Box 8206            * 
 *                      Raleigh, NC 27695-8206                      * 
 *                               and                                *
 *           MCNC, North Carolina Supercomputing Center             *
 *              Environmental Programs, P.O. Box 12889              *
 *                 Research Triangle Park, 27709                    *
 *                                                                  * 
 *      Made available under terms of the GNU Public License        *
 *                                                                  * 
 ********************************************************************/

char busXt_cv[] = "@(#)busXt.c	1.4 /tmp_mnt/pub/storage/edss/framework/src/bus/bus_src/SCCS/s.busXt.c 02 Sep 1996 16:45:20" ;

/********************************************************************
                    About:  EDSS_SB - busXt.c

  Bus routines for handling X-window and Motif events (for use with
  X-based and Motif-based clients).

 KNOWN BUGS:  :-(

 OTHER NOTES: :-)

 ********************************************************************/

/********************************************************************
                 History: EDSS_SB - busXt.c

 Date: 14-Dec-94
 Version: 0.1
 Change Description: ORIGINAL CODE  
 Change author: Leland Morrison, NCSU, CSC 

 Date: 15-Dec-94
 Version: 0.2
 Change Description: Added some comments and main headers
 Change author: M. Vouk, NCSU, CSC

 Date: 17-Jan-95
 Version: 0.3
 Change Description: Added 2 extra dummy parameters to BusXtInputDispatch
		to make it compatible with SGIs. 
 Change author: Rajini Balay, NCSU, CSC

 Date: 10-Mar-95
 Version: 0.4
 Change Description: Equated xtid to null before close.
 Change author: M. Vouk, NCSU, CSC

 Date: 24-July-95
 Version: 0.6a
 Change Description: Changed call to BusInitialize to conform with new iface.
 Change author: R. Balay, NCSU, CSC

 ********************************************************************/

#include "busXtClient.h"
#include "busError.h"
#include "busDebug.h"

extern int masterAlive;

void BusXtInputDispatch( XtPointer bd, int *dummy, XtInputId *id )
{
  int err;

  err = BusDispatch( (struct BusData *)bd );
  if (err != SBUSERROR_NOT) {
     printf("CONNECTION TO BUS HAS CLOSED \n");
     if (err == SBUSERROR_NODATA) {
	masterAlive = 0;

        /* Remove the Input Callback from XtAppContext */
	BusXtClose((struct BusData *)bd);
     }

  }
}

int BusXtInitialize(struct BusData *bd,XtAppContext app_context)
{
  int err;
  
  /* Initialize as an infinite life process */
  err = BusInitialize( bd, -1, 0, NULL );
  
  if(err == SBUSERROR_NOT)
    bd->xtd->xtid = XtAppAddInput(
				       app_context,
				       bd->fd,
				       XtInputReadMask,
				       BusXtInputDispatch,
				       (XtPointer)bd
				       );
  return err;
}

void BusXtClose( struct BusData *bd )
{
  if (bd->xtd != NULL && bd->xtd->xtid != 0) {
     XtRemoveInput( bd->xtd->xtid );
     bd->xtd->xtid = NULL;
  }
  
  BusClose( bd );
}

