/* so that this header isn't included twice... */
#ifndef SBUS_MASTER_RTFUNCS_H_INCLUDED
#define SBUS_MASTER_RTFUNCS_H_INCLUDED

#ifdef SBUS_INCLUDE_HDR_DEFN
static char *vhmasterRTFuncs=
/********************************************************************
 *                                                                  *
 *                        EDSS Software Bus                         */
  "EDSS_SB masterRTFuncs.h 0.4/prt/ncsu.csc/morrison.vouk/18-Mar-94";
/*                                                                  *
 *                     Copyright (c) 1994 by                        *
 *                                                                  *
 *                  North Carolina State University                 *
 *              Department of Computer Science, Box 8206            *
 *                      Raleigh, NC 27695-8206                      *
 *                               and                                *
 *           MCNC, North Carolina Supercomputing Center             *
 *              Environmental Programs, P.O. Box 12889              *
 *                 Research Triangle Park, 27709                    *
 *                                                                  *
 *      Made available under terms of the GNU Public License        *
 *                                                                  *
 ********************************************************************/
#endif

/* @(#)masterRTFuncs.h	1.3 /tmp_mnt/pub/storage/edss/framework/src/bus/bus_src/SCCS/s.masterRTFuncs.h 08 Sep 1995 10:58:26" */

/********************************************************************
                    About:  EDSS_SB - masterRTFuncs.h

  Prototypes for bust master run-time functions.

 ********************************************************************/

/********************************************************************
                 History: EDSS_SB - masterRTFuncs.h

 Date: 14-Dec-94
 Version: 0.1
 Change Description: ORIGINAL VERSION 
 Change author: Leland Morrison, NCSU, CSC 

 Date: 15-Dec-94
 Version: 0.2
 Change Description: Added some comments and main headers
 Change author: Vouk

 Date: 27-Jan-95
 Version: 0.3a
 Change Description: Modified definition of BusMasterBroadcast to
                     take 'struct BusMessage *' as a parameter instead
		     of 'struct BusMessage'.
 Change author: Rajini Balay, CSC, NCSU.

 Date: 18-March-95
 Version: 0.4
 Change Description: Added definitions for BusMasterRTGetModuleInfoByName 
                     and BusMasterRTGetModuleInfoById
 Change author: Balay, R.

 Date: 12-Apr-95
 Version: 0.5a
 Change Description: Definition for the function BusMasterRTKillClient
 Change author: Balay, R.

 ********************************************************************/
#include "busMaster.h"

int BusMasterRTResetConnection  (struct BusMasterData *,
				 struct BusModuleNode *, struct BusMessage *);
int BusMasterRTModuleLeaving    (struct BusMasterData *,
				 struct BusModuleNode *);
int BusMasterRTProcessMessage       (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);
int BusMasterRTPassMessage      (struct BusMasterData *,
				 struct BusModuleNode *);
int BusMasterRTFindModuleByName (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);
int BusMasterRTFindModuleById   (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);
int BusMasterRTGetModuleInfoByName (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);
int BusMasterRTGetModuleInfoById   (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);

int BusMasterRTFindTypeByName   (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);
int BusMasterRTFindTypeById     (struct BusMasterData *,
			         struct BusModuleNode *, struct BusMessage *);
int BusMasterRTTellWhosConnected(struct BusMasterData *,
				 struct BusModuleNode *, struct BusMessage *);
int BusMasterRTReqDirect  (struct BusMasterData *,
				 struct BusModuleNode *, struct BusMessage *);
int BusMasterRTReplyDirect  (struct BusMasterData *,
				 struct BusModuleNode *, struct BusMessage *);
int BusMasterRTKillClient  (struct BusMasterData *,
				 struct BusModuleNode *, struct BusMessage *);

void BusMasterBroadcast( struct BusMasterData *bmd, struct BusMessage *bmsg );

#endif
