#include <stdio.h>
#include <MapProjections.h>     /* For public functions.                   */
#include <MapProjectionsInfo.h> /* For getMapProjectionVisibility().        */
#include <MapUtilities.h>       /* For M3IOParameters and public functions. */


main()
{

  M3IOParameters params;
  MapProjection mapProjection;


  params.gdtyp = POLGRD3;
  params.p_alp = 1;
  params.p_bet = 60.;
  params.p_gam = -105.;
  params.xcent = 0.;
  params.ycent = 90.;
  params.nrows = 880;
  params.ncols = 1160;
  params.xorig =  -2100262.5;
  params.yorig =  -7624762.5;
  params.xcell = 4762.5;
  params.ycell = 4762.5;
  params.corners[LOWER][LAT] =   10.0;
  params.corners[LOWER][LON] = -125.0;
  params.corners[UPPER][LAT] =   80.0;
  params.corners[UPPER][LON] =  -60.0;
  params.ellipse = 1;

  createMapProjection( &params, &mapProjection );
  if ( setMapProjection( &mapProjection ) )
    {
      double lat, lon;
      double x, y;
      double projectedXOrigin;
      double projectedYOrigin;
      float  origx, origy, dx, dy;
      
      computeProjectedGridOrigin(&params, 
				 &projectedXOrigin,
				 &projectedYOrigin);

      printf("DEBUG:proj origin %f %f\n",projectedXOrigin,projectedYOrigin);

      lat=22.7736;
      lon=239.624;

      projectLatLon(lat, lon, &x, &y);

      printf("X=%f Y=%f\n",x,y);

    }
}
    
