/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)fdesc3.h	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_drawmap/SCCS/s.fdesc3.h
 * Last updated: 12/15/97 16:24:19
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

#ifndef    FDESC3_DEFINED
#define    FDESC3_DEFINED


/************************************************************************
C  INCLUDE FILE  fdesc3.h
C
C  CONTAINS:  
C       File description typedefs for C bindings to the I/O API
C
C  DEPENDENT UPON:  
C       consistency with FORTRAN include-files PARMS33.EXT, FDESC3.EXT
C
C  REVISION HISTORY:  
C       prototype 5/9/95 by CJC
C
**************************************************************************/

#include   "parms3.h"

/*************************************************************************      
        Typedef for a MODELS 3 file description:  same memory layout
        as the FORTRAN COMMONs BDESC3 and CDESC3.
**************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

typedef char   M3Name[ NAMLEN3 ] ; /* Models3 Fortran "name" objects  */
typedef char   M3Line[ MXDLEN3 ] ; /* ... "description-line" objects  */
                
typedef struct { 
               double p_alp ;   /*  first, second, third map */  
               double p_bet ;   /*  projection descriptive   */  
               double p_gam ;   /*  parameters.              */  
               double xcent ;   /*  lon for coord-system X=0 */  
               double ycent ;   /*  lat for coord-system Y=0 */  
               double xorig ;   /*  X-coordinate origin of grid (map units) */
               double yorig ;   /*  Y-coordinate origin of grid  */  
               double xcell ;   /*  X-coordinate cell dimension  */  
               double ycell ;   /*  Y-coordinate cell dimension  */
               int    ftype ;   /*  file type                    */  
               int    cdate ;   /*  creation date   YYYYDDD      */  
               int    ctime ;   /*  creation time    HHMMSS      */  
               int    wdate ;   /*  update date     YYYYDDD      */  
               int    wtime ;   /*  update time      HHMMSS      */  
               int    sdate ;   /*  file start date YYYYDDD      */  
               int    stime ;   /*  file start time  HHMMSS      */  
               int    tstep ;   /*  file time step   HHMMSS      */  
               int    mxrec ;   /*  max time step record number  */  
               int    nvars ;   /*  number of species            */  
               int    ncols ;   /*  number of grid columns       */  
               int    nrows ;   /*  number of grid rows          */  
               int    nlays ;   /*  number of layers             */  
               int    nthik ;   /*  BOUNDARY:  perimeter thickness (cells)  */  
               int    gdtyp ;   /*  grid type:  1=LAT-LON, 2=LAM, ...       */  
               int    vgtyp ;   /*  vertical coordinate type (VGSIGP3, ...) */
               float  vgtop ;   /*  model-top, for sigma coord types.       */  
               float  vglvs[ MXLAYS3 + 1 ] ;  /*  vertical coord values.    */ 
               int    vtype[ MXVARS3 ] ; /* basic data type M3INT, ... */
               }
               IOAPI_Bdesc3 ;

typedef struct { 
               M3Name  gdnam ;  /* grid name                       */ 
               M3Name  upnam ;  /* last program writing to file    */ 
               M3Line  execn ;  /* value of env vble EXECUTION_ID  */ 
               M3Line  fdesc[ MXDESC3 ] ; /* file description      */ 
               M3Line  updsc[ MXDESC3 ] ; /* update   "            */
               M3Name  vname[ MXVARS3 ] ; /* variable names        */
               M3Name  units[ MXVARS3 ] ; /*   "      units        */
               M3Line  vdesc[ MXVARS3 ] ; /*   "      descriptions */
               }
               IOAPI_Cdesc3 ;

#ifdef __cplusplus
}    /** END 'extern "c"' **/
#endif



/****************   END   fdesc3.h   ***********************************/


#endif    /*   FDESC3_DEFINED  */
