/////////////////////////////////////////////////////////////
//
// Project Title: Environmental Decision Support System
//         File: @(#)BaseType.cc	2.1
//     Pathname: /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.BaseType.cc
// Last updated: 12/15/97 16:31:42
//
// Made available by MCNC and the Carolina Environmental Program of UNC Chapel
// Hill under terms of the GNU Public License.  See gpl.txt for more details.
//
// See file COPYRIGHT for license information on this and supporting software.
//
// Carolina Environmental Program
// University of North Carolina at Chapel Hill
// 137 E. Franklin St.
// Chapel Hill, NC 27599-6116
//
// See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
//
/////////////////////////////////////////////////////////////

static const char *SCCS_ID = "@(#)BaseType.cc	2.1 /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.BaseType.cc 12/15/97 16:31:42";

/////////////////////////////////////////////////////////////
//
// BaseType.C
// Steve Thorpe
// thorpe@ncsc.org
// NCSC Environmental Programs, MCNC
// May 23, 1995
//
/////////////////////////////////////////////////////////////
//
// BaseType Class 
//
// Portions from Roger Sessions' "Class Construction in C
// and C++", copyright 1992 by Prentice-Hall
//
/////////////////////////////////////////////////////////////
//
// Revision History
// SRT	950523	Implemented
//
/////////////////////////////////////////////////////////////


#include "BaseType.h"


static void terminate(char *);



baseType::~baseType()
{
}


int baseType::match(void *target)
{
fprintf(stderr, "match(%ld)\n", (long)target);
terminate("match");
return 0;
}


void baseType::print(FILE *output)
{
fprintf(stderr, "print(%ld)\n", (long)output);
terminate("print");
}


void terminate(char *methodName)
{
printf("Method %s\ninvoked, but not implemented for this type\n",
	methodName);
exit(0);
}


	// the assumption here is that every derived class
	// will override this method, using a similar method
	// but replacing the string baseType with the name
	// of its own class
char *baseType::getClassName()
{
static char *myName = "baseType";
return myName;
}
