/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)BasicComponent.cc	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.BasicComponent.cc
 * Last updated: 12/15/97 16:31:45
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)BasicComponent.cc	2.1 /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.BasicComponent.cc 12/15/97 16:31:45";

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//         This example code is from the book:
//
//           Object-Oriented Programming with C++ and OSF/Motif
//         by
//           Douglas Young
//           Prentice Hall, 1992
//           ISBN 0-13-630252-1	
//
//         Copyright 1991 by Prentice Hall
//         Hill under terms of the GNU Public License.  See gpl.txt for more details.
//
//  Permission to use, copy, modify, and distribute this software for 
//  any purpose except publication and without fee is hereby granted, provided 
//  that the above copyright notice appear in all copies of the software.
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////
// BasicComponent.C: Initial version of a class to define 
//                    a protocol for all components
///////////////////////////////////////////////////////////
#include "BasicComponent.h"

BasicComponent::BasicComponent ( const char *name )
{
    _w = (Widget) NULL;
    assert ( name != NULL );  // Make sure programmers provide name
    _name = strdup ( name );
}

BasicComponent::~BasicComponent()
{
    if( _w )
	XtDestroyWidget ( _w );
    if (_name) /* SRT delete _name */  free(_name); _name = (char *) NULL;

}

void BasicComponent::manage()
{
    assert ( _w != NULL );
    if (XtIsManaged(_w)) XtUnmanageChild(_w); XtManageChild ( _w );
}

void BasicComponent::unmanage()
{
    assert ( _w != NULL );
    XtUnmanageChild ( _w );
}
