/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)ComboData.cc	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.ComboData.cc
 * Last updated: 12/15/97 16:32:22
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)ComboData.cc	2.1 /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.ComboData.cc 12/15/97 16:32:22";

//////////////////////////////////////////////////////////////////////
//	ComboData.C
//	K. Eng Pua
//	Copyright (C)
//	Jan 28, 1995
//	
//  NOTE: :
//  NOTE: not finish yet.  need more work
//////////////////////////////////////////////////////////////////////

#include "ComboData.h"


void ComboData::initialize()
{
   title1_ = NULL;
   title2_ = NULL;
   title3_ = NULL;
   xtitle_ = NULL;
   ytitle_ = NULL;
   val_x_  = NULL;
   val_xs_ = NULL;
   val_y_  = NULL;
   y_label_list_ = NULL;

   // Defaults
   sprintf(plotformatX_, "%cg", '%');
   if ((getenv("BARPLOTYFORMAT") != NULL) && (strlen(getenv("BARPLOTYFORMAT"))))
   	sprintf(plotformatY_, "%s", getenv("BARPLOTYFORMAT"));
   else
   	sprintf(plotformatY_, "%cg", '%');
   offset_left_ = offset_top_ = 100;
   offset_right_ = offset_bottom_ = 60;
}



void ComboData::setTitles(char *t1, char *t2, char *t3, char *xt, char *yt)
{
   if (title1_) { delete title1_; title1_ = NULL; } 
   if (title2_) { delete title2_; title2_ = NULL; }
   if (title3_) { delete title3_; title3_ = NULL; }
   if (xtitle_) { delete xtitle_; xtitle_ = NULL; }
   if (ytitle_) { delete ytitle_; ytitle_ = NULL; }

   if (t1) title1_ = strdup(t1);
   if (t2) title2_ = strdup(t2);
   if (t3) title3_ = strdup(t3);
   if (xt) xtitle_ = strdup(xt);
   if (yt) ytitle_ = strdup(yt);
}


void ComboData::setDataArray(float *x, float *y, int y_num, int obs_num)
{
   int idy = 0;
   int i, j;

   if (val_x_) delete val_x_; 
   if (val_y_) delete val_y_; 

   y_data_num_ = y_num;
   obs_num_ = obs_num;

#ifdef DIAGNOSTICS
fprintf(stderr, "Y_DATA_NUM=%d OBS_NUM=%d\n", y_num, obs_num);
fprintf(stderr, "Y_DATA_NUM=%d OBS_NUM=%d\n", y_data_num_, obs_num_);
#endif // DIAGNOSTICS

   val_x_  = new float[obs_num_];
   val_y_  = new float[obs_num_*y_data_num_];
   val_xs_ = new str20[obs_num_];

   val_ymax_ = -999.9;
   val_ymin_ = 999.9;

   for (i = 0; i < obs_num_; i++) {
	val_x_[i] = x[i];		
        sprintf(val_xs_[i], "%g ", val_x_[i]);

        for (j = 0; j < y_data_num_; j++) {
                idy = i*y_data_num_ + j;
		val_y_[idy] = y[idy];
                if ( val_y_[idy] > val_ymax_ )
                        val_ymax_ = val_y_[idy];
                if ( val_y_[idy] < val_ymin_ )
                        val_ymin_ = val_y_[idy];
        }
   }
   val_xmin_ = 0;
   val_xmax_ = (float) ((y_data_num_+1) * obs_num_) + 1.0;
   if (val_ymin_ > 0.0) val_ymin_ -= val_ymin_*0.1;
}



