/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)Shell.cc	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.Shell.cc
 * Last updated: 12/15/97 16:34:02
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)Shell.cc	2.1 /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.Shell.cc 12/15/97 16:34:02";

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Shell.C
// K. Eng Pua
// Dec 14, 1994
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Shell.h"

Shell::Shell ( AppInit *app, char *name ) : UIComponent(name)
{
    _w = shell_ = XtCreatePopupShell ( _name,
			      applicationShellWidgetClass,
			      app->baseWidget(),
			      NULL, 0 );

    installDestroyHandler();

	// added SRT 961014 
    XtVaSetValues ( 	shell_,

                        XmNdeleteResponse, XmDO_NOTHING,   // do nothing if the
							   // user double-clicks
							   // the upper left of the
							   // motif window, rather
							   // than delete it

                        XmNmwmFunctions, MWM_FUNC_RESIZE |	// don't show the
                                         MWM_FUNC_MOVE |	// window manager's 
                                         MWM_FUNC_MINIMIZE |	// close and delete 
                                         MWM_FUNC_MAXIMIZE,	// menu items in 
								// this window
                        NULL );
}


void Shell::manage()
{
    assert ( shell_ );
    XtPopup ( shell_, XtGrabNone );

    // Map the window, in case the window is iconified

    if ( XtIsRealized ( shell_ ) )
        XMapRaised ( XtDisplay ( shell_ ), XtWindow ( shell_ ) );
}


void Shell::unmanage()
{
    assert ( shell_ );
    XtPopdown ( shell_ );
}


void Shell::iconify()
{
    assert ( shell_ );
    
    // Set the widget to have an initial iconic state
    // in case the base widget has not yet been realized

    XtVaSetValues ( shell_, XmNiconic, TRUE, NULL );

    // If the widget has already been realized,
    // iconify the window

    if ( XtIsRealized ( shell_ ) )
        XIconifyWindow ( XtDisplay ( shell_ ), XtWindow ( shell_ ), 0 );
}


