/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)Util.cc	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.Util.cc
 * Last updated: 12/15/97 16:34:28
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)Util.cc	2.1 /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.Util.cc 12/15/97 16:34:28";

///////////////////////////////////////////////////////////
// Util.C
//////////////////////////////////////////////////////////
#include "Util.h"

Util::Util ()
{
   // Empty constructor
}


char *Util::file2string(char * filename)
{
  FILE *fp;
  static char *content;
  int size;
  struct stat statbuf;

  if (content) free(content);

  if ( (fp = fopen(filename, "r")) != NULL ) {
	/* Determine the size of file */
	fstat(fileno(fp), &statbuf);

	/* Allocate memory for buffer */
	content = (char*) malloc(sizeof(char)*(int)(statbuf.st_size)+2);

	fseek(fp, 0, SEEK_SET);

	/* Read file to buffer */
	for (size=0; !feof(fp); size++) content[size]=fgetc(fp);
	content[size-1] = '\0';
	fclose(fp);
	return(content);
  }
  else {
	fprintf(stderr, "Input File not found. Can't convert it into string.\n");

	return (char *) NULL;  
  }
}


//********************************************************************************************

Message::Message(Widget parent, int dialog_type, char *msg)
{
   assert(parent);
   assert(msg);

   if (!msg[0]) 
	{
	fprintf(stderr, "Empty msg supplied to Message!\n");
	return;
	}
   Widget dialog = XmCreateMessageDialog(parent, "Message", NULL, 0);
   XmString xmstr = XmStringCreateLtoR(msg, XmSTRING_DEFAULT_CHARSET);
   XtVaSetValues(dialog,
        XmNdialogType,  dialog_type,
        XmNmessageString,       xmstr,
        NULL);
   XmStringFree(xmstr);
   XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));
   XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
//   XtAddCallback(dialog, XmNokCallback, XtDestroyWidget, NULL);
   if (XtIsManaged(dialog)) XtUnmanageChild(dialog);  XtManageChild(dialog);
}

