C*DK FILEINI2
      SUBROUTINE FILEINI2
C########################################################################
C**     opens and reads the header information from
C**     the second initial conditions file, or positions to the correct
C**     file position for the c2 file for restart.
C**    revision history:
C**    no.    date    who  what
C**    __    _____    ___  ____________________________________________
C**    02    89       jny  initial condition file positioning code (mcb)
C**    01    89150    jkv  implementation
C**
C**    input files: opens i2,c2 files
C**
C**    output files:none
C*************************************************************************

      include "a_params.com"
      include "a_logdb.com"
      include "a_i2desc.com"
      include "a_c2desc.com"
      include "a_iopts.com"
      include "a_filfmt.com"
      include "a_units.com"
      logical  firstime
      data     firstime  /.true./
      save     firstime

      if (firstime) then
        firstime = .false.
        CALL FILEOPEN(I2UNIT,'I2',I2FMT)    !open I2 file
        CALL RDUFH(I2UNIT,I2HSTR,I2FMT)     !read universal file header
        CALL RDFD(I2UNIT,I2FDSTR,I2FMT)     !read file descriptor
        DO 10 I = 1,LC3D2E-LC3D1E           !read species group
          CALL RDSPR(I2UNIT,I2SSN(I),I2SLN(I),I2SUN(I),I2SMAP(I),I2FMT)
10      CONTINUE
        CALL RDTEXT(I2UNIT,I2TEXT,I2FMT)    !read text group
      endif
C       read the time step header including checksum info
C       on the first call...
        CALL RDTSH(I2UNIT,I2HFT,I2TSHR,I2FMT)
        WRITE(6,*)' TSH- UNIT: ',I2UNIT,'  I2DATE: ',I2DATE,
     1         '  I2TIME: ',I2TIME
C

      RETURN
      END
