C**********************************************************************
*DK FILEOPEN
      SUBROUTINE FILEOPEN(IOLUN,NAME,LFMT)
C#######################################################################
C**     opens file 'name' on assigned fortran lun 'iolun',
C**     as either formatted or unformatted depending on 'lfmt'.
C**    revision history:
C**    no.    date    who  what
C**    __    _____    ___  ____________________________________________
C**    01    89150    jkv  implementation
C**
C**    input files:  none
C**
C**    output files:none
C***********************************************************************
C     ----------
      CHARACTER*(*) NAME
      INTEGER IOLUN,IOST
      LOGICAL LFMT
      LUNOUT=6
      IF (LFMT) THEN
         OPEN(UNIT=IOLUN,FILE=NAME,STATUS='UNKNOWN',FORM='FORMATTED',
     1        IOSTAT=IOST)
         IF (IOST .NE. 0) THEN
           WRITE(LUNOUT,10) IOLUN, NAME, IOST
10         FORMAT(' ERROR ON FORMATTED OPEN, UNIT: ',I2,' NAME: ',A30,
     1            '  IOSTATUS: ',I8)
           CALL EXIT
         ELSE
           WRITE(LUNOUT,11) IOLUN,NAME
11         FORMAT(1x,78('*')/' **** FORMATTED OPEN, UNIT: ',I3,
     1            ', FILE: ',A30,'   ****'/1x,78('*'))
         END IF
      ELSE
         OPEN(UNIT=IOLUN,FILE=NAME,STATUS='UNKNOWN',FORM='UNFORMATTED',
     1        IOSTAT=IOST)
         IF (IOST.NE.0) THEN
           WRITE(LUNOUT,101) IOLUN, NAME, IOST
101        FORMAT(' ERROR ON UNFORMATTED OPEN, UNIT: ',I2,' NAME: ',
     1     A30,'  IOSTATUS: ',I8)
           CALL EXIT
         ELSE
           WRITE(LUNOUT,111) IOLUN,NAME
111        FORMAT(1x,78('*')/'*** UNFORMATTED OPEN, UNIT: ',I3,
     1            ', FILE: ',A30,'   ****'/1x,78('*'))
         END IF
      ENDIF
      RETURN
      END
