#! /bin/csh -f
# C-shell script to run NL2 aggregation run on SEQUOIA
#QSUB -r tranconc -lUb 1 -lm 4.0Mw -lt 600
#QSUB -eo -o /flyer/com/a/saqm02/saqm/tranconc/saqm_m3_conc.log
##QSUB -q us_epa1

date;set timestamp;set echo

# These are the parameters for this run, set them carefully
set CASE     = a9                 # the case number of this run              <
set DATE     = 90214              # the beginning date for this run          <
set EDATE    = 90214              # the end date for this run                <
set ESCEN    = b85                # the emissions scenario used for this run <
set PHASE    = 1                  # the phase for this run                   <
set IBEGHR   = 12                 # the beginning hour for this run          <
set IENDHR   = 00                 # the ending hour for this run             <
set METPP    = m14                # met pre-processor supplying inputs       <
set NHRS     = 121                 # number of hours for this run             <
#set NHRS     = 49                 # number of hours for this run             <
set NUMTS    = 121                # total number of emissions time steps     <
set PROG     = pa                 # for RADM 2.6                             <
set VERSION  = 0                  # version
set BASE     = /flyer/com/a/saqm02/saqm/tranconc
set FORM     = net                # netCDF data format

set ICBC     = /tmp/saqm/careyj/output
set INDIR    = /tmp/saqm/careyj/output
#set ICBC     = /dmf/saqm/careyj/output
#set INDIR    = /dmf/saqm/careyj/output
set I1       = s12slsh.a90c15x.eeBaseN.scf915x.c1
set I2       = s12slsh.a90c15x.eeBaseN.scf915x.c2

set IC1      = s12slsh.a90c15x.eeBaseN.scf915x.m3c12
#
#
cd $BASE
set ASSIGN   = .assign.$$
unalias rm
set UI = ui.$$
cat >! $UI << E$O$F               # Create user input file for model
$NHRS
E$O$F

#
##############################################################
#                  Set up for model run                      #
##############################################################

if (-e $ICBC/$IC1) rm $ICBC/$IC1

rm $ASSIGN
setenv INIT_CONC_1  $ICBC/$IC1
setenv FILENV $ASSIGN
#
if (!(-e  $INDIR/$I1)) exit(10)
#assign -a $INDIR/$I1  I1 # ICBC fort.14 (input)
#assign -a $INDIR/$I1 -F f77  -N ieee_dp I1 # ICBC fort.14 (input)
assign -a $INDIR/$I1 -F f77 -N ieee  I1 # ICBC fort.14 (input)

if (!(-e  $INDIR/$I2)) exit(10)
#assign -a $INDIR/$I2  I2 # ICBC fort.15 (input)
#assign -a $INDIR/$I2 -F f77  -N ieee_dp I2 # ICBC fort.15 (input)
assign -a $INDIR/$I2 -F f77 -N ieee  I2 # ICBC fort.15 (input)

# make
#
# test to see if things went ok
if ($status != 0) exit(11)
#
# cdbx $BASE/tranconc; exit
 ja ; $BASE/tranconc_ha < $UI
 ja -cshlt
rm $ASSIGN
exit(77) 
