C*DK FILEINBC
      SUBROUTINE FILEINBC
C########################################################################
C**     reads the header information from the model
C**     boundary conditions file.
C**    revision history:
C**    no.    date    who  what
C**    __    _____    ___  ____________________________________________
C**    02    89       jny  check for seasonal compatibility added
C**    01    89150    jkv  implementation
C**
C**    input files:
C**
C**    output files:none
C*************************************************************************

      include "a_logdb.com"
      include "a_params.com"
      include "a_bcdesc.com"
      include "a_iopts.com"
      include "a_filfmt.com"
      include "a_units.com"

        CALL FILEOPEN(BCUNIT,'BC',BCFMT)
C       read the universal file header, file descriptor record, and
C       the species group records and the text records from the file

C       call rdufh to read the file header
        CALL RDUFH(BCUNIT,BCHSTR,BCFMT)

C       call rdfd to read the file descriptor
        CALL RDFD(BCUNIT,BCFDSTR,BCFMT)

C       read values from the species records

        DO 10 I = 1,LSPEC
          CALL RDSPR(BCUNIT,BCSSN(I),BCSLN(I),BCSUN(I),BCSMAP(I),BCFMT)
10      CONTINUE

C       read text group from file header
        CALL RDTEXT(BCUNIT,BCTEXT,BCFMT)
C
C       read the time step header including checksum info
C       on the first and only call.
        CALL RDTSH(BCUNIT,BCHFT,BCTSHR,BCFMT)
        WRITE(6,*)' TSH- UNIT: ',BCUNIT,'  BCDATE: ',BCDATE,
     1         '  BCTIME: ',BCTIME
C
C
      RETURN
      END
