C*DK FILEINI1
      SUBROUTINE FILEINI1
C########################################################################
C   data definition for new header structures
C***********************************************************************
C**     opens and reads the header information from
C**     the first initial conditions file, or positions to the correct
C**     file position in the c1 file for restart.
C**    revision history:
C**    no.    date    who  what
C**    __    _____    ___  ____________________________________________
C**    02    89       jny  initial condition file positioning code (mcb)
C**    01    89150    jkv  implementation
C**
C**    input files: opens i1 file
C**
C**    output files:none
C*************************************************************************

      include "a_params.com"
      include "a_logdb.com"
      include "a_i1desc.com"
      include "a_c1desc.com"
      include "a_iopts.com"
      include "a_filfmt.com"
      include "a_units.com"
      logical  firstime
      data     firstime  /.true./
      save     firstime

      if (firstime) then
        firstime = .false.
        CALL FILEOPEN(I1UNIT,'I1',I1FMT)     !open I1 file
        CALL RDUFH(I1UNIT,I1HSTR,I1FMT)      !read universal file header
        CALL RDFD(I1UNIT,I1FDSTR,I1FMT)      !read file descriptor
        DO 10 I = 1,LC3D1E
          CALL RDSPR(I1UNIT,I1SSN(I),I1SLN(I),I1SUN(I),I1SMAP(I),I1FMT)
10      CONTINUE
        CALL RDTEXT(I1UNIT,I1TEXT,I1FMT)     !read text group
      endif
C       read the time step header including checksum info
C       on the first call...
        CALL RDTSH(I1UNIT,I1HFT,I1TSHR,I1FMT)
        WRITE(6,*)'TSH- UNIT: ',I1UNIT,'  I1DATE: ',I1DATE,
     1         '  I1TIME: ',I1TIME

      RETURN
      END
