
      subroutine filbuf(BUFIC)
C
C******
C**   DESCRIPTION:  Translate Engineer Model icbc file from
C**     IBM format to netCDF format for models3.
C**
C**     1 Revision History:
C**       No. Date     Who     What
C**       --  ----     ---     ----
C**        0  2/17/92  HWANG   BEGIN PROGRAM
C**        1 10/25/96  CAREYJ  Convert SAQM output to Models-3 format,
C**
C**
C**      2 Calls the following subroutines: BUFIN CKSUMER
C******
C**  CALL FILEINIC(LC3D1E)
C******
C
C**   INCLUDE FILES:
      INCLUDE 'a_params.com'
      INCLUDE 'a_i1desc.com'
      INCLUDE 'a_i2desc.com'
      INCLUDE 'a_iopts.com'
      INCLUDE 'a_filfmt.com'
      INCLUDE 'a_units.com'
      INCLUDE 'a_cmmns.com'
C
      INCLUDE 'DIMS3.EXT'
C      INCLUDE 'CONST3.EXT'
      INCLUDE 'PARMS3.EXT'
      INCLUDE 'FDESC3.EXT'
      INCLUDE 'IODECL3.EXT'
      INCLUDE 'RADM.EXT'
C      real*4  VCI1(JMAX,KMAX,LC3D2E+1,IMAX)
cj
cj  ***** Array for extra hourly average data array
cj  ***** Currently it is not written to converted Models-3 format file 

cj      REAL  VCI_HA(JMAX,LC3D2E+1,IMAX)
cj 
      REAL          BUFIC(NCOLS, NROWS, NLAYS, NSPCS)

C**   DECLARATION OF INTERNAL VARIABLES
      REAL         CK1,  CK2
      CHARACTER*12 SCK1, SCK2

C
C
C             --- read in initial conditions into VCI array (in PPM)
      DO 104 ISLAB=1,IMAX
cj
cj  ***** Read only hourly average data array

         CALL RDSLAB(I1UNIT,VCI(1,1,1,ISLAB),JMAX*KMAX*LC3D1E)
         CALL RDSLAB(I2UNIT,VCI(1,1,LC3D2S,ISLAB),
     &                JMAX*KMAX*(LC3D2E-LC3D2S+1))
c         CALL RDSLAB(I1UNIT,VCI_HA(1,1,ISLAB),JMAX*LC3D1E)
c         CALL RDSLAB(I2UNIT,VCI_HA(1,LC3D2S,ISLAB),
c     &                JMAX*(LC3D2E-LC3D2S+1))
cj
104   CONTINUE
        goto 990
        CALL CKSUMER(1,CK1,SCK1)
        CALL CKSUMER(2,CK2,SCK2)
        WRITE(6,*)
        WRITE(6,*) ' CKSUMER I1 RETURNED: ',CK1, SCK1
        WRITE(6,*) ' CKSUMER I2 RETURNED: ',CK2, SCK2
        IF (I1CBUF(1:12) .NE. SCK1(1:12)) THEN
           WRITE(6,101) I1CBUF,SCK1
        END IF
101     FORMAT(1X,' I1 FILE CHKSUM: ',A12,
     1            ' CURRENT PROCESS CHKSUM: ',A12)
        WRITE(6,*)
        IF (I2CBUF(1:12) .NE. SCK2(1:12)) THEN
           WRITE(6,102) I2CBUF,SCK2
        END IF
102     FORMAT(1X,' I2 FILE CHKSUM: ',A12,
     1            ' CURRENT PROCESS CHKSUM: ',A12)

c
990      continue
         DO 40 isp = 1, LSPEC
         DO 40 ila = 1, NLAYS
         DO 40 ico = 1, NCOLS
         DO 40 iro = 1, NROWS
            BUFIC(ico,iro,ila,map(isp,2)) = 
     &                        VCI(iro+NTHIK,ila,map(isp,1),ico+NTHIK)
 40      CONTINUE
         DO 41 isp = LSPEC+1, NSPCS
         DO 41 ila = 1, NLAYS
         DO 41 ico = 1, NCOLS
         DO 41 iro = 1, NROWS
            BUFIC(ico,iro,ila,map(isp,2)) = 0.0
 41      CONTINUE

c

888     format(I5)
889     format(I6)
92999   FORMAT ( //5X, A, // )

91000   FORMAT ( //5X , '*** ERROR ABORT in program TRANICBC ***',
     &            /5X , A , // )        !  generic error message format
C
      return
      END
